#ifndef STM32_BASIC_H
#define STM32_BASIC_H

/*{ stm32_basic.h ***********************************************
 
 * Written by Gregor Rebel 2010-2012
 *
 * Basic datatypes, enums and functions
 * 
}*/

typedef unsigned char        u8_t;
typedef unsigned short int  u16_t;
typedef unsigned long       u32_t;
typedef signed char          s8_t;
typedef signed short int    s16_t;
typedef signed int          s32_t;
typedef enum { FALSE=0, TRUE } BOOL;
typedef BOOL bool;

#ifndef NULL
#define NULL 0
#endif

typedef enum ErrorCode_E {
  ec_None,                           // 0
  ec_Malloc,                         // 1
  ec_NULL,
  ec_InvalidArgument,
  ec_UNKNOWN
} ErrorCode_e;

//{ Function prototypes **************************************************

/* Will block endlessly if Condition is false. Use it to check arguments and system states.
 * @param Condition  =0: Assert() will block in an endless while-loop; !=0: Assert() returns immediately
 * @param ErrorCode  developers hint why condition has failed
 * @return value of Condition
 */
bool Assert(volatile bool Condition, volatile ErrorCode_e ErrorCode);


//}Function prototypes
#endif
