/*{ ttc_multitask.c ***********************************************
 
 * Written by Gregor Rebel 2010-2012
 *
 * Scheduler and architecture independent multitasking support.
 * 
}*/
#include "ttc_multitask.h"

void programCalibrateUSleep() {                               // produces software PWM usable to calibrate uSleep() 
  
#ifdef TTC_LED1
  ttc_Port_t Port_LED1;
  ttc_initPort(&Port_LED1, TTC_LED1, tgm_output_push_pull);
  
  while (1) {
    ttc_portSet(&Port_LED1);
    uSleep(1000);           // 1ms high time
    ttc_portClr(&Port_LED1);
    uSleep(100);            // 100us low time
  }
#else
  Assert(0, ec_UNKNOWN); // programCalibrateUSleep() requires definition of TTC_LED1! (E.g.; #define TTC_LED1 PA7)
#endif
}
void mSleep(u32_t Delay) {                                    // set task to sleep for some amount of time 

    for (;Delay > 0; Delay--)
      uSleep(1000);
}
void uSleep(u32_t Delay) {                                    // set task to sleep for some amount of time

    Delay *= configTICK_RATE_HZ; // smallest delay depends on tick rate <-- test setting via programCalibrateUSleep()
    Delay /= 1000000;

    while (Delay > 0xffff) { // split long delays into smaller ones
      vTaskDelay(Delay & 0xffff);
      Delay -= 0xffff;
    }
    vTaskDelay(Delay);
}
