#ifndef TTC_MULTITASK_H
#define TTC_MULTITASK_H

/*{ ttc_multitask.h ***********************************************
 
 * Written by Gregor Rebel 2010-2012
 *
 * Architecture independent support for multitasking.
 * 
 * Currently implemented architectures: stm32 + FreeRTOS
 * 
}*/

//{ includes

#include "ttc_basic.h"
#include "ttc_gpio.h"
//? #ifdef TARGET_ARCHITECTURE_STM32
  //? #include "stm32_gpio.h"
  //? #include <stdlib.h>
  //? #include "stm32f10x.h"
  //? #include "core_cm3.h"
  //? #include "stm32f10x_conf.h"
  //? #include "stm32f10x_gpio.h"
//? #endif

#ifdef EXTENSION_300_scheduler_free_rtos
  #include <string.h>
  #include "stddef.h"
  #include "FreeRTOS.h"
  #include "task.h"
#endif


//}includes

//{ Function prototypes **************************************************

/* produces software PWM usable to calibrate uSleep() 
 * Idea: Connect oscilloscope to pin PA1 (pin 15 on STM32F103) an check for correct period (1,1ms) and duty cycle.
 *        Adjust uSleep() accordingly, recompile, reflash and retest.
 */
void programCalibrateUSleep();

/* Set task to sleep for some amount of time
 * @param Delay    delay time (msecs)
*/
void mSleep(u32_t Delay); 

/* set task to sleep for some amount of time
 * @param Delay    delay time (usecs)
 */
void uSleep(u32_t Delay);


//}Function prototypes

#endif
