/*{ ttc_spi::.c ************************************************
 
                      The ToolChain
                      
   Device independent support for 
   
   
   written by Gregor Rebel 2012
   
 
}*/

#include "ttc_spi.h"

//{ Function definitions *************************************************

inline                  u8_t ttc_getMax_SPI_Index() {

#ifdef TARGET_ARCHITECTURE_STM32
    return TTC_AMOUNT_SPIS;
#endif

    return 0;
}
inline ttc_spi_errorcode_e ttc_getSPI_Defaults(u8_t SPI_Index, ttc_spi_generic_t* SPI_Generic) {
    memset(SPI_Generic, 0, sizeof(SPI_Generic));
    
#ifdef TARGET_ARCHITECTURE_STM32
    return stm32_getSPI_Defaults(SPI_Index, SPI_Generic);
#endif

  return tue_DeviceNotFound;  
}
inline ttc_spi_errorcode_e ttc_getSPI_Features(u8_t SPI_Index, ttc_spi_generic_t* SPI_Generic) {
    memset(SPI_Generic, 0, sizeof(SPI_Generic));
    
#ifdef TARGET_ARCHITECTURE_STM32
    return stm32_getSPI_Features(SPI_Index, SPI_Generic);
#endif

  return tue_DeviceNotFound;
}
inline ttc_spi_errorcode_e ttc_initSPI(u8_t SPI_Index, ttc_spi_generic_t* SPI_Generic, ttc_spi_architecture_u* SPI_Arch) {
    memset(SPI_Arch, 0, sizeof(SPI_Arch));

#ifdef TARGET_ARCHITECTURE_STM32
  return stm32_initSPI(SPI_Index, SPI_Generic, (stm32_spi_architecture_t*) SPI_Arch);
#endif

  return tue_DeviceNotFound;
}
inline ttc_spi_errorcode_e ttc_sendRaw(u8_t SPI_Index, const char* Buffer, u16_t Amount) {
  
#ifdef TARGET_ARCHITECTURE_STM32
  return stm32_spi_sendBytes(SPI_Index, Buffer, Amount);
#endif

  return tue_DeviceNotFound;
}
inline ttc_spi_errorcode_e ttc_sendASCII(u8_t SPI_Index, const char* Buffer, u16_t MaxLength) {
  
#ifdef TARGET_ARCHITECTURE_STM32
  return stm32_spi_sendASCII(SPI_Index, Buffer, MaxLength);
#endif

  return tue_DeviceNotFound;
}
inline ttc_spi_errorcode_e ttc_sendWord(u8_t SPI_Index, const u16_t Word) {

#ifdef TARGET_ARCHITECTURE_STM32
  return stm32_spi_sendWord(SPI_Index, Word);
#endif

  return tue_DeviceNotFound;
}
inline ttc_spi_errorcode_e ttc_readWord(u8_t SPI_Index, u16_t* Word, u32_t TimeOut) {

#ifdef TARGET_ARCHITECTURE_STM32
  return stm32_spi_readWord(SPI_Index, Word, TimeOut);
#endif

  return tue_DeviceNotFound;
}
inline ttc_spi_errorcode_e ttc_readByte(u8_t SPI_Index, char* Byte, u32_t TimeOut) {

#ifdef TARGET_ARCHITECTURE_STM32
  return stm32_spi_readByte(SPI_Index, Byte, TimeOut);
#endif

  return tue_DeviceNotFound;
}

//} Function definitions
